----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:57:59 11/10/2011 
-- Design Name: 
-- Module Name:    Ctrl4x7Seg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Ctrl4x7Seg is
    port (clk_in:     in std_logic;
          reset_in:   in std_logic;
          bcd0_in:    in std_logic_vector (3 downto 0);
          bcd1_in:    in std_logic_vector (3 downto 0);
          bcd2_in:    in std_logic_vector (3 downto 0);
          bcd3_in:    in std_logic_vector (3 downto 0);
          char_out:  out std_logic_vector (6 downto 0);
          chsel_out: out std_logic_vector (3 downto 0));
end Ctrl4x7Seg;

architecture Behavioral of Ctrl4x7Seg is

--  component BinTo7Seg
--    port ( InBin:   in std_logic_vector (3 downto 0);
--           OutSeg: out std_logic_vector (6 downto 0));
--  end component;
--
--  component Mux4To1 is
--    port ( input0:  in std_logic_vector (3 downto 0);
--           input1:  in std_logic_vector (3 downto 0);
--           input2:  in std_logic_vector (3 downto 0);
--           input3:  in std_logic_vector (3 downto 0);
--           output: out std_logic_vector (3 downto 0);
--           sel   :  in integer range 0 to 3);
--  end component;
--
--  signal   count_clk: integer range 0 to 1000000;
--  signal   mux_sel:   integer range 0 to 3;
--  signal   demux_digit: std_logic_vector (3 downto 0);
--  signal   bcd0_reg:    std_logic_vector (3 downto 0);
--  signal   bcd1_reg:    std_logic_vector (3 downto 0);
--  signal   bcd2_reg:    std_logic_vector (3 downto 0);
--  signal   bcd3_reg:    std_logic_vector (3 downto 0);

begin

  process(clk_in, reset_in)
  begin
    if reset_in = '1' then
      count_clk <= 0;
      mux_sel <= 0;
      bcd0_reg <= "0000";
      bcd1_reg <= "0000";
      bcd2_reg <= "0000";
      bcd3_reg <= "0000";
    elsif rising_edge(clk_in) then
      if count_clk = 100000 then
        count_clk <= 0;
        
        bcd0_reg <= bcd0_in;
        bcd1_reg <= bcd1_in;
        bcd2_reg <= bcd2_in;
        bcd3_reg <= bcd3_in;
        
        if mux_sel /= 3 then
          mux_sel <= mux_sel + 1;
        else
          mux_sel <= 0;
        end if;
      else
        count_clk <= count_clk + 1;
      end if;
    end if;
  end process;

--  with mux_sel select
--    chsel_out <= "1110" when 0,
--                 "1101" when 1,
--                 "1011" when 2,
--                 "0111" when 3;
--
--  I1: Mux4To1   port map (bcd0_reg, bcd1_reg, bcd2_reg, bcd3_reg, demux_digit, mux_sel);
--  I2: BinTo7Seg port map (demux_digit, char_out);

end Behavioral;

