----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:55:14 11/24/2011 
-- Design Name: 
-- Module Name:    NAND_Adress - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--********************************************************************************
entity NAND_Adress is
    Port ( CLK:      in STD_LOGIC;
           RST:      in STD_LOGIC;
           START:    in STD_LOGIC;
           ENDE:    out STD_LOGIC;
           ALE:     out STD_LOGIC;
           WE:      out STD_LOGIC;
           DataIn:   in STD_LOGIC_VECTOR(7 downto 0);
           DataOut: out STD_LOGIC_VECTOR(7 downto 0));
end NAND_Adress;
--********************************************************************************
architecture Behavioral of NAND_Adress is
  type TADRStatus is ( cIDLE, cSTART, cSET_WE, cRES_WE, cENDE);
  signal ADRStatus: TADRStatus;
begin
  CmdProc: process (CLK, RST)
    --variable ADRStatus: TADRStatus;
  begin
    if RST = '0' then
      ALE       <= '0';
      ENDE      <= '0';
      DataOut   <= (others=>'0');      
      ADRStatus <= cIDLE;
    elsif (CLK'event) then
      case ADRStatus is
        when cIDLE   => if START = '1' then            ADRStatus <= cSTART; end if;
        when cSTART  => ALE <= '1';                    ADRStatus <= cSET_WE;
        when cSET_WE =>             DataOut <= DataIn; ADRStatus <= cRES_WE;
        when cRES_WE =>                                ADRStatus <= cENDE;
        when cENDE   => ALE <= '0'; ENDE    <= '1';    ADRStatus <= cIDLE;
      end case;      
    end if;
  end process;

  with ADRStatus select WE      <=    '0' when cSET_WE,    '1' when cRES_WE,           'Z' when others;
  
end Behavioral;
--********************************************************************************
