----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:20:29 03/27/2012 
-- Design Name: 
-- Module Name:    NAND_In - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--********************************************************************************
entity NAND_In is
    Port ( CLK:      in STD_LOGIC;
           RST:      in STD_LOGIC;
           START:    in STD_LOGIC;
           ENDE:    out STD_LOGIC;
         --LE:      out STD_LOGIC;
           RE:      out STD_LOGIC;
           DataIn:   in STD_LOGIC_VECTOR(7 downto 0);
           DataOut: out STD_LOGIC_VECTOR(7 downto 0));
end NAND_In;
--********************************************************************************
architecture Behavioral of NAND_In is
  type TStatus is ( cIDLE, cSET_RE, cRES_RE, cENDE);
  signal Status: TStatus;
begin
  StatusProc: process (CLK, RST)
    --variable Status: TStatus;
  begin
    if RST = '0' then
      Status <= cIDLE;
    elsif (CLK'event) then
      case Status is
        when cIDLE   => if START = '1' then Status <= cSET_RE; end if;
        when cSET_RE =>                     Status <= cRES_RE;
        when cRES_RE =>                     Status <= cENDE;
        when cENDE   =>                     Status <= cIDLE;
      end case;      
    end if;
  end process;

  with Status select RE      <=    '0' when cSET_RE,                                '1' when others;
--with Status select LE      <=    '0' when cIdle,      '0' when cEnde,             '1' when others;
  with Status select DataOut <= DataIn when cSET_RE, DataIn when cRES_RE, (others=>'0') when others;
  with Status select ENDE    <=    '1' when cEnde,                                  '0' when others;

end Behavioral;
--********************************************************************************
