----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:47:36 11/24/2011 
-- Design Name: 
-- Module Name:    NAND_Out - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--********************************************************************************
entity NAND_Out is
    Port ( CLK:      in STD_LOGIC;
           RST:      in STD_LOGIC;
           START:    in STD_LOGIC;
           ENDE:    out STD_LOGIC;
           LE:      out STD_LOGIC;
           WE:      out STD_LOGIC;
           DataIn:   in STD_LOGIC_VECTOR(7 downto 0);
           DataOut: out STD_LOGIC_VECTOR(7 downto 0));
end NAND_Out;
--********************************************************************************
architecture Behavioral of NAND_Out is
  type TStatus is ( cIDLE, cSET_WE, cRES_WE, cENDE);
  signal Status: TStatus;
begin
  StatusProc: process (CLK, RST)
    --variable Status: TStatus;
  begin
    if RST = '0' then
      Status <= cIDLE;
    elsif (CLK'event) then
      case Status is
        when cIDLE   => if START = '1' then Status <= cSET_WE; end if;
        when cSET_WE =>                     Status <= cRES_WE;
        when cRES_WE =>                     Status <= cENDE;
        when cENDE   =>                     Status <= cIDLE;
      end case;      
    end if;
  end process;

  with Status select WE      <=    '0' when cSET_WE,                                '1' when others;
  with Status select LE      <=    '0' when cIdle,      '0' when cEnde,             '1' when others;
  with Status select DataOut <= DataIn when cSET_WE, DataIn when cRES_WE, (others=>'0') when others;
  with Status select ENDE    <=    '1' when cEnde,                                  '0' when others;

end Behavioral;
--********************************************************************************
