--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:10:35 03/26/2012
-- Design Name:   
-- Module Name:   C:/Users/KNE/NAND-Flash-Reader/tb.vhd
-- Project Name:  NAND-Flash-Reader
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: FlashInterface
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb IS
END tb;
 
ARCHITECTURE behavior OF tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT NAND_Model
    PORT(
         Lock : IN std_logic;
         Cle : IN std_logic;
         Ale : IN std_logic;
         Clk_We_n : IN std_logic;
         Wr_Re_n : IN std_logic;
         Ce_n : IN std_logic;
         Wp_n : IN std_logic;    
         Dq_Io : INOUT std_logic_vector(7 downto 0);      
         Rb_n : OUT std_logic
         );
    END COMPONENT;

    COMPONENT FlashInterface
    PORT(
         CLK : IN  std_logic;
         RST : IN  std_logic;
         STA : IN  std_logic;
         WP : OUT  std_logic;
         RE : OUT  std_logic;
         WE : OUT  std_logic;
         CE : OUT  std_logic;
         ALE : OUT  std_logic;
         CLE : OUT  std_logic;
         RB : IN  std_logic;
         DIS : OUT  std_logic;
         IOPort : INOUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal CLK : std_logic := '0';
   signal RST : std_logic := '0';
   signal STA : std_logic := '1';
   signal RB  : std_logic;

	--BiDirs
   signal IOPort : std_logic_vector(7 downto 0);

 	--Outputs
   signal WP : std_logic;
   signal RE : std_logic;
   signal WE : std_logic;
   signal CE : std_logic;
   signal ALE : std_logic;
   signal CLE : std_logic;
   signal DIS : std_logic;

   -- Clock period definitions
   constant CLK_period : time := 16.66666666666666666666666666666666666666666 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: FlashInterface PORT MAP (
          CLK => CLK,
          RST => RST,
          STA => STA,
          WP => WP,
          RE => RE,
          WE => WE,
          CE => CE,
          ALE => ALE,
          CLE => CLE,
          RB => RB,
          DIS => DIS,
          IOPort => IOPort
        );

	I_NAND: NAND_Model PORT MAP(Lock     => WP,
		                          Dq_Io    => IOPort,
		                          Cle      => CLE,
		                          Ale      => ALE,
		                          Clk_We_n => WE,
		                          Wr_Re_n  => RE,
		                          Ce_n     => CE,
		                          Wp_n     => WP,
		                          Rb_n     => RB
	                            );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin
     
     RST <= '0'; wait for CLK_period*7; 
     RST <= '1'; wait for CLK_period;
     STA <= '0'; wait for CLK_period; 
     STA <= '1'; wait for CLK_period; 
     

     wait;
   end process;

END;
